## balboa 2.0.0+ds

=== backend/Makefile ===

MAKEFLAGS+=--no-print-directory

all: rocksdb console mock

rocksdb:
	${MAKE} -C balboa-rocksdb

console:
	${MAKE} -C balboa-backend-console

mock:
	${MAKE} -C balboa-mock

sqlite:
	${MAKE} -C balboa-sqlite

style:
	clang-format -i \
		lib/protocol.{c,h} lib/engine.{c,h} lib/daemon.{c,h} lib/alloc.h lib/trace.{c,h} \
		balboa-rocksdb/rocksdb-impl.{c,h} balboa-rocksdb/main.c \
		balboa-mock/mock-impl.{c,h} balboa-mock/main.c \
		balboa-sqlite/sqlite-impl.{c,h} balboa-sqlite/main.c \
		balboa-backend-console/main.c

clean:
	${MAKE} -C balboa-mock clean
	${MAKE} -C balboa-backend-console clean
	${MAKE} -C balboa-rocksdb clean
	${MAKE} -C balboa-sqlite clean

=== backend/balboa-backend-console/Makefile ===

CROSS_HOST?=$(shell uname -m)
CROSS_PREFIX?=
CCOMPILER?=gcc

OUT=build/

CFLAGS?=
CFLAGS+=-pipe -static -s -Ofast -flto

ifeq ($(CCOMPILER),gcc)
CFLAGS+=-fwhole-program -fmax-errors=3 -D__GCC__
endif

ifeq ($(CCOMPILER),clang)
CFLAGS+=-D__CLANG__
endif

CFLAGS+=-std=c11 -Wall -Wextra -D_GNU_SOURCE -D__TRACE__ -DNDEBUG
CFLAGS+=-I. -I../lib
CFLAGS+=-DMPACK_HAS_CONFIG
LDFLAGS?=
LDFLAGS+=-pthread

MAKEFLAGS+=--no-print-directory

CC=$(CROSS_PREFIX)$(CCOMPILER)

hdr-lib=bs.h trace.h protocol.h engine.h mpack-config.h
hdr-lib-y=$(addprefix ../lib/,$(hdr-lib))

src-console=mpack.c trace.c protocol.c engine.c
src-console-y=$(addprefix ../lib/,$(src-console)) main.c

target-console-y=$(OUT)$(CROSS_PREFIX)balboa-backend-console

dirs-y=.

all: $(target-console-y)

$(OUT)build:
	@echo "    mkdir"
	$(Q)mkdir -p $(addprefix $(OUT),$(dirs-y))
	$(Q)touch $@

$(target-console-y): Makefile $(OUT)build $(src-console-y) $(hdr-lib-y) Makefile
	$(CC) $(CFLAGS) $(src-console-y) -o $(target-console-y) $(LDFLAGS)

clean:
	rm -f $(target-console-y)
	rm -f $(OUT)build
	rmdir $(OUT)

=== backend/balboa-mock/Makefile ===

CROSS_HOST?=$(shell uname -m)
CROSS_PREFIX?=
CCOMPILER?=gcc

OUT=build/

CFLAGS?=
CFLAGS+=-pipe -static -s -Ofast -flto

ifeq ($(CCOMPILER),gcc)
CFLAGS+=-fwhole-program -fmax-errors=3 -D__GCC__
endif

ifeq ($(CCOMPILER),clang)
CFLAGS+=-D__CLANG__
endif

CFLAGS+=-std=c11 -Wall -Wextra -D_GNU_SOURCE -D__TRACE__ -DNDEBUG
CFLAGS+=-I. -I../lib
CFLAGS+=-DMPACK_HAS_CONFIG
LDFLAGS?=
LDFLAGS+=-pthread

MAKEFLAGS+=--no-print-directory

CC=$(CROSS_PREFIX)$(CCOMPILER)

hdr-balboa-mock=engine.h trace.h daemon.h
hdr-balboa-mock-y=$(addprefix ../lib/,$(hdr-balboa-mock)) mock-impl.h mpack-config.h

src-balboa-mock=trace.c daemon.c protocol.c mpack.c engine.c
src-balboa-mock-y=$(addprefix ../lib/,$(src-balboa-mock))
src-balboa-mock-y+=mock-impl.c main.c

target-balboa-mock-y=$(OUT)$(CROSS_PREFIX)balboa-mock

dirs-y=.

all: $(target-balboa-mock-y)

$(OUT)build:
	@echo "    mkdir"
	$(Q)mkdir -p $(addprefix $(OUT),$(dirs-y))
	$(Q)touch $@

$(target-balboa-mock-y): $(OUT)build $(src-balboa-mock-y) $(hdr-balboa-mock-y) Makefile
	$(CC) $(CFLAGS) $(src-balboa-mock-y) -o $(target-balboa-mock-y) $(LDFLAGS)

clean:
	rm -f $(target-balboa-mock-y)
	rm -f $(OUT)build
	rmdir $(OUT)

=== backend/balboa-rocksdb/Makefile ===

CROSS_HOST?=$(shell uname -m)
CROSS_PREFIX?=
CCOMPILER?=gcc

OUT=build/

CFLAGS?=
CFLAGS+=-pipe -Ofast -flto

ifdef DEBUG
CFLAGS+=-ggdb
else
CFLAGS+=-s
endif

ifeq ($(CCOMPILER),gcc)
CFLAGS+=-fwhole-program -fmax-errors=3 -D__GCC__
endif

ifeq ($(CCOMPILER),clang)
CFLAGS+=-D__CLANG__
endif

CFLAGS+=-std=c11 -Wall -Wextra -D_GNU_SOURCE -D__TRACE__ -DNDEBUG
CFLAGS+=-I. -I../lib
CFLAGS+=-DMPACK_HAS_CONFIG

LDFLAGS?=
LDFLAGS+=-lrocksdb -pthread

MAKEFLAGS+=--no-print-directory

CC=$(CROSS_PREFIX)$(CCOMPILER)

hdr-balboa-rocksdb=protocol.h engine.h trace.h daemon.h mpack.h mpack-config.h
hdr-balboa-rocksdb-y=$(addprefix ../lib/,$(hdr-balboa-rocksdb)) rocksdb-impl.h

src-balboa-rocksdb=trace.c daemon.c protocol.c engine.c mpack.c
src-balboa-rocksdb-y=$(addprefix ../lib/,$(src-balboa-rocksdb))
src-balboa-rocksdb-y+=rocksdb-impl.c main.c

target-balboa-rocksdb-y=$(OUT)$(CROSS_PREFIX)balboa-rocksdb

dirs-y=.

all: $(target-balboa-rocksdb-y)

$(OUT)build:
	@echo "    mkdir"
	$(Q)mkdir -p $(addprefix $(OUT),$(dirs-y))
	$(Q)touch $@

$(target-balboa-rocksdb-y): $(OUT)build $(src-balboa-rocksdb-y) $(hdr-balboa-rocksdb-y) Makefile
	$(CC) $(CFLAGS) $(src-balboa-rocksdb-y) -o $(target-balboa-rocksdb-y) $(LDFLAGS)

clean:
	rm -f $(target-balboa-rocksdb-y)
	rm -f $(OUT)build
	rmdir $(OUT)

## balboa 1.0

=== debian/changelog ===
balboa (1.0-3) unstable; urgency=medium

  * Do not hardcode shared lib dependency in binary package.
    Closes: #915599

 -- Sascha Steinbiss <satta@debian.org>  Wed, 05 Dec 2018 10:52:41 +0100

balboa (1.0-2) unstable; urgency=medium

  * Update rocksdb dependency to 5.15.
  * Use /run in service file.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 04 Dec 2018 14:06:33 +0100

balboa (1.0-1) unstable; urgency=low

  * Initial release (Closes: #913313)

 -- Sascha Steinbiss <satta@debian.org>  Sun, 11 Nov 2018 00:29:35 +0100

=== debian/control ===
Source: balboa
Section: net
Priority: optional
Maintainer: Sascha Steinbiss <satta@debian.org>
Build-Depends: debhelper (>= 11),
 dh-golang,
 golang-go,
 golang-github-machinebox-graphql-dev,
 golang-github-graph-gophers-graphql-go-dev,
 golang-github-satori-go.uuid-dev,
 golang-github-spf13-cobra-dev,
 golang-github-spf13-viper-dev,
 golang-github-go-sql-driver-mysql-dev,
 golang-github-sirupsen-logrus-dev,
 golang-github-neowaylabs-wabbit-dev,
 golang-github-gocql-gocql-dev,
 golang-github-willfaught-gockle-dev,
 golang-github-data-dog-go-sqlmock-dev,
 librocksdb-dev (>= 5.15),
 libtpl-dev
Standards-Version: 4.2.1
XS-Go-Import-Path: github.com/DCSO/balboa
Vcs-Browser: https://salsa.debian.org/debian/balboa
Vcs-Git: https://salsa.debian.org/debian/balboa.git
Homepage: https://github.com/DCSO/balboa

Package: balboa
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Built-Using: ${misc:Built-Using}
Description: Passive DNS database with GraphQL interface
 balboa is the BAsic Little Book Of Answers. It consumes and indexes
 observations from passive DNS collection, providing a GraphQL interface
 to access the aggregated contents of the observations database.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1
export DH_GOPKG := github.com/DCSO/balboa
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_GOLANG_INSTALL_EXTRA := testdata

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/man

override_dh_auto_build:
	dh_auto_build
	mkdir -p debian/man
	find . -executable -wholename '*bin/balboa' -exec {} makeman --dir debian/man \;

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/balboa-$1\.tar\.gz/ \
  https://github.com/DCSO/balboa/tags .*/v?(\d\S+)\.tar\.gz

## balboa 2.0.0%2Bds

=== debian/watch ===
version=4
opts=repacksuffix=+ds,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/balboa-$1\.tar\.gz/ \
  https://github.com/DCSO/balboa/tags .*/v?(\d\S+)\.tar\.gz

## balboa 2.0.0+ds

=== debian/changelog ===
balboa (2.0.0+ds-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Skip dh_dwz step in d/rules.
  * Require Golang from backports.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 17 Sep 2020 15:28:24 +0200

balboa (2.0.0+ds-3) unstable; urgency=medium

  * Patch Makefiles to add `-latomic'. Fixes FTBFS on mips and others.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 23 Jul 2019 16:57:06 +0200

balboa (2.0.0+ds-2) unstable; urgency=medium

  * Fix build on MIPS systems.
  * Bump Standards-Version.
  * Use debhelper 12.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 23 Jul 2019 14:58:12 +0200

balboa (2.0.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Separate into multiple binary packages to reflect new upstream structure
    (frontend/backend/maintenance).
  * Create manpages.
  * Do not ship database.yml any more since it is no longer needed.
  * Repack upstream code to remove unneeded embedded third party code.
  * Adapt autopkgtests.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 13 Jul 2019 08:50:06 +0200

=== debian/control ===
Source: balboa
Section: net
Priority: optional
Maintainer: Sascha Steinbiss <satta@debian.org>
Build-Depends: debhelper (>= 12),
 dh-golang,
 golang-go (>= 2:1.12),
 golang-github-machinebox-graphql-dev,
 golang-github-graph-gophers-graphql-go-dev,
 golang-github-satori-go.uuid-dev,
 golang-github-spf13-cobra-dev,
 golang-github-spf13-viper-dev,
 golang-github-go-sql-driver-mysql-dev,
 golang-github-sirupsen-logrus-dev (>= 1.0.1),
 golang-github-neowaylabs-wabbit-dev,
 golang-github-gocql-gocql-dev,
 golang-github-data-dog-go-sqlmock-dev,
 golang-github-ugorji-go-codec-dev (>= 1.1.1),
 librocksdb-dev (>= 5.15),
 help2man
Standards-Version: 4.4.0
XS-Go-Import-Path: github.com/DCSO/balboa
Vcs-Browser: https://salsa.debian.org/debian/balboa
Vcs-Git: https://salsa.debian.org/debian/balboa.git
Homepage: https://github.com/DCSO/balboa

Package: balboa
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Built-Using: ${misc:Built-Using}
Recommends: balboa-backend-rocksdb
Description: Passive DNS database with GraphQL interface, frontend
 balboa is the BAsic Little Book Of Answers. It consumes and indexes
 observations from passive DNS collection, providing a GraphQL interface
 to access the aggregated contents of the observations database.
 .
 This package contains the frontend, which handles user query interaction
 and input parsing. It requires a backend to store the consumed observations.

Package: balboa-backend-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: balboa
Description: Common files for balboa backends
 balboa is the BAsic Little Book Of Answers. It consumes and indexes
 observations from passive DNS collection, providing a GraphQL interface
 to access the aggregated contents of the observations database.
 .
 This package contains files common to all backends available in Debian,
 such as systemd unit files and management tools.

Package: balboa-backend-rocksdb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, balboa-backend-common
Description: RocksDB backend for balboa
 balboa is the BAsic Little Book Of Answers. It consumes and indexes
 observations from passive DNS collection, providing a GraphQL interface
 to access the aggregated contents of the observations database.
 .
 This package contains the RocksDB backend.

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,20 @@
 	dh_auto_clean
 	rm -rf debian/man
 
+override_dh_installsystemd:
+	dh_installsystemd -p balboa balboa.service
+	dh_installsystemd -p balboa-backend-common --no-enable --no-start \
+	  --name=balboa-backend@ balboa-backend@.service
+
+override_dh_dwz:
+	# pass
+
 override_dh_auto_build:
 	dh_auto_build
 	mkdir -p debian/man
 	find . -executable -wholename '*bin/balboa' -exec {} makeman --dir debian/man \;
+	make -C backend
+	help2man --no-discard-stderr -N -n 'RocksDB backend for balboa' \
+	       	backend/balboa-rocksdb/build/balboa-rocksdb > debian/man/balboa-rocksdb.1
+	help2man --no-discard-stderr -N -n 'Backend maintenance console for balboa' \
+		backend/balboa-backend-console/build/balboa-backend-console > debian/man/balboa-backend-console.1

## balboa 2.1.0+ds

=== debian/changelog ===
balboa (2.1.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Add new build-dependencies introduced by new upstream release.
  * Bump Golang dependency to 1.23.
  * Add new config files.
  * Some cosmetics in autopkgtest script.
  * Slim down the default input feeders.
  * Ensure the correct defaults file is used for backend service.
  * Remove patches applied upstream.
  * Bump Standards-Version.
  * Add patches to enable reconnection and protocol parity.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 09 Jul 2025 21:41:54 +0200

balboa (2.0.0+ds-7) unstable; urgency=medium

  * Stop building static binaries for the backend tools.
    Thanks to Aurelien Jarno for noticing and raising this.
    Closes: #1106793

 -- Sascha Steinbiss <satta@debian.org>  Sun, 01 Jun 2025 12:15:09 +0200

balboa (2.0.0+ds-6) unstable; urgency=medium

  * Ensure multiple builds can be done in same directory.
    Done by ensuring the directory is cleaned correctly.
    Closes: #1043821

 -- Sascha Steinbiss <satta@debian.org>  Sat, 18 Nov 2023 13:27:31 +0100

balboa (2.0.0+ds-5) unstable; urgency=medium

  * Switch from golang-github-streadway-amqp-dev to
    golang-github-rabbitmq-amqp091-dev-go, which is the current
    line of development.
  * Add upstream metadata.
  * Switch to debhelper-compat 13.
  * Add Rules-Requires-Root: no.
  * Bump Standards-Version.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 22 Jan 2023 09:13:57 +0100

balboa (2.0.0+ds-4) unstable; urgency=medium

  * Remove autogenerated date/time in manpage.
    This helps make the build reproducible.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 02 Nov 2021 09:42:55 +0100

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: net
 Priority: optional
 Maintainer: Sascha Steinbiss <satta@debian.org>
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 13),
  dh-golang,
- golang-go (>= 2:1.12),
+ golang-go (>= 2:1.23~),
  golang-github-machinebox-graphql-dev,
  golang-github-graph-gophers-graphql-go-dev,
  golang-github-satori-go.uuid-dev,
@@ -13,12 +13,18 @@
  golang-github-go-sql-driver-mysql-dev,
  golang-github-sirupsen-logrus-dev (>= 1.0.1),
  golang-github-neowaylabs-wabbit-dev,
+ golang-github-rabbitmq-amqp091-go-dev,
  golang-github-gocql-gocql-dev,
  golang-github-data-dog-go-sqlmock-dev,
  golang-github-ugorji-go-codec-dev (>= 1.1.1),
+ golang-github-yuin-gopher-lua-dev,
+ golang-github-farsightsec-go-nmsg-dev,
+ golang-github-gogo-protobuf-dev,
+ golang-github-golang-protobuf-1-5-dev,
  librocksdb-dev (>= 5.15),
  help2man
-Standards-Version: 4.4.0
+Standards-Version: 4.7.2
+Rules-Requires-Root: no
 XS-Go-Import-Path: github.com/DCSO/balboa
 Vcs-Browser: https://salsa.debian.org/debian/balboa
 Vcs-Git: https://salsa.debian.org/debian/balboa.git

## balboa 2.1.2+ds

=== debian/changelog ===
balboa (2.1.2+ds-3) unstable; urgency=medium

  * Skip test on big-endian systems.

 -- Sascha Steinbiss <satta@debian.org>  Mon, 12 Jan 2026 11:48:54 +0100

balboa (2.1.2+ds-2) unstable; urgency=medium

  * Make sure that created data directories are removed on purge.
  * Add patch to extend test waiting time for NMSG format test.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 11 Jan 2026 22:31:47 +0100

balboa (2.1.2+ds-1) unstable; urgency=medium

  * New upstream release:
    - Add new build-dependencies introduced by new upstream release.
    - Bump Golang dependency to 1.23.
    - Add new config files.
    - Some cosmetics in autopkgtest script.
    - Slim down the default input feeders.
    - Ensure the correct defaults file is used for backend service.
    - Bump Standards-Version.
    - Add patches to enable reconnection and protocol parity.
  * Remove patches applied upstream.
  * Add upgrade handling for transitions from 2.0.x:
    - Add debian/NEWS documenting configuration changes.
    - Add debian/README.Debian with upgrade guidance.
    - Update postinst to warn if /etc/default/balboa is missing the
      required -b flag for backend.yaml.
    - Update NEWS and README.Debian to match warn-only behavior.
  * Add Static-Built-Using fields to Go binary packages.
  * Add lintian overrides for debian/watch signature checking and
    spelling errors in the balboa binary.
  * Fix Upstream-Name in debian/copyright.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 10 Jan 2026 10:37:31 +0100

balboa (2.0.0+ds-8) unstable; urgency=medium

  * Work toward better reproducibility by honoring SOURCE_DATE_EPOCH and
    setting the correct date in man page generation.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 30 Nov 2025 02:13:06 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  golang-github-spf13-cobra-dev,
  golang-github-spf13-viper-dev,
  golang-github-go-sql-driver-mysql-dev,
- golang-github-sirupsen-logrus-dev (>= 1.0.1),
+ golang-github-sirupsen-logrus-dev,
  golang-github-neowaylabs-wabbit-dev,
  golang-github-rabbitmq-amqp091-go-dev,
  golang-github-gocql-gocql-dev,
@@ -34,6 +34,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
 Built-Using: ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Recommends: balboa-backend-rocksdb
 Description: Passive DNS database with GraphQL interface, frontend
  balboa is the BAsic Little Book Of Answers. It consumes and indexes
@@ -47,6 +48,8 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: balboa
+Built-Using: ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Description: Common files for balboa backends
  balboa is the BAsic Little Book Of Answers. It consumes and indexes
  observations from passive DNS collection, providing a GraphQL interface
@@ -58,6 +61,8 @@
 Package: balboa-backend-rocksdb
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, balboa-backend-common
+Built-Using: ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Description: RocksDB backend for balboa
  balboa is the BAsic Little Book Of Answers. It consumes and indexes
  observations from passive DNS collection, providing a GraphQL interface
